package com.example.backend.model;

import lombok.Data;

import java.util.Objects;
import java.util.List;
@Data
public class RadarStatus {
    private String model;
    private String serialNumber;
    private String type;
    private String connectionType;
    private String startupTime;
    private double detectionProbability;
    private double falseAlarmRate;
    private int scanCycle;
    private int beamAzimuth;
    private int beamElevation;
    private double antennaGain;
    private double sideLobeGain;
    private String platformId;
    // Getters and Setters

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getSerialNumber() {
        return serialNumber;
    }

    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getConnectionType() {
        return connectionType;
    }

    public void setConnectionType(String connectionType) {
        this.connectionType = connectionType;
    }

    public String getStartupTime() {
        return startupTime;
    }

    public void setStartupTime(String startupTime) {
        this.startupTime = startupTime;
    }

    public double getDetectionProbability() {
        return detectionProbability;
    }

    public void setDetectionProbability(double detectionProbability) {
        this.detectionProbability = detectionProbability;
    }

    public double getFalseAlarmRate() {
        return falseAlarmRate;
    }

    public void setFalseAlarmRate(double falseAlarmRate) {
        this.falseAlarmRate = falseAlarmRate;
    }

    public int getScanCycle() {
        return scanCycle;
    }

    public void setScanCycle(int scanCycle) {
        this.scanCycle = scanCycle;
    }

    public int getBeamAzimuth() {
        return beamAzimuth;
    }

    public void setBeamAzimuth(int beamAzimuth) {
        this.beamAzimuth = beamAzimuth;
    }

    public int getBeamElevation() {
        return beamElevation;
    }

    public void setBeamElevation(int beamElevation) {
        this.beamElevation = beamElevation;
    }

    public double getAntennaGain() {
        return antennaGain;
    }

    public void setAntennaGain(double antennaGain) {
        this.antennaGain = antennaGain;
    }

    public double getSideLobeGain() {
        return sideLobeGain;
    }

    public void setSideLobeGain(double sideLobeGain) {
        this.sideLobeGain = sideLobeGain;
    }

    public String getPlatformId() {
        return platformId;
    }

    public void setPlatformId(String platformId) {
        this.platformId = platformId;
    }

    @Override
    public String toString() {
        return "RadarStatus{" +
                "model='" + model + '\'' +
                ", serialNumber='" + serialNumber + '\'' +
                ", type='" + type + '\'' +
                ", connectionType='" + connectionType + '\'' +
                ", startupTime='" + startupTime + '\'' +
                ", detectionProbability=" + detectionProbability +
                ", falseAlarmRate=" + falseAlarmRate +
                ", scanCycle=" + scanCycle +
                ", beamAzimuth=" + beamAzimuth +
                ", beamElevation=" + beamElevation +
                ", antennaGain=" + antennaGain +
                ", sideLobeGain=" + sideLobeGain +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        RadarStatus that = (RadarStatus) o;
        return Double.compare(that.detectionProbability, detectionProbability) == 0 &&
                Double.compare(that.falseAlarmRate, falseAlarmRate) == 0 &&
                scanCycle == that.scanCycle &&
                beamAzimuth == that.beamAzimuth &&
                beamElevation == that.beamElevation &&
                Double.compare(that.antennaGain, antennaGain) == 0 &&
                Double.compare(that.sideLobeGain, sideLobeGain) == 0 &&
                model.equals(that.model) &&
                serialNumber.equals(that.serialNumber) &&
                type.equals(that.type) &&
                connectionType.equals(that.connectionType) &&
                startupTime.equals(that.startupTime);
    }

    @Override
    public int hashCode() {
        return Objects.hash(model, serialNumber, type, connectionType, startupTime, detectionProbability,
                falseAlarmRate, scanCycle, beamAzimuth, beamElevation, antennaGain, sideLobeGain);
    }
}
